from flask import current_app, Blueprint, render_template

from .npc_party import create_party


npc_views = Blueprint(
    'npc_views',
    __name__,
    template_folder='templates',
    url_prefix='/npc'
)

@npc_views.route('/party')
@npc_views.route('/party/<int:base_level>')
def generate_npc_party(base_level=None):
    party = None
    if base_level:
        party = create_party(base_level)
    return render_template('generate_npc_party.html', party=party)
